#ifdef _KX_GLOBAL_MODULE_
 #ifdef EXTERN
   #undef EXTERN
 #endif
 #define EXTERN
 #define GVarV( tn, v ) tn = v
 #define _ ,
#else
  #define GVarV( tn, v ) extern tn
  #define EXTERN extern
#endif

#ifndef _KXGLOBAL_H_
#define _KXGLOBAL_H_

#ifndef _KXTYPE_H_
#include "kxtype.h"
#endif

EXTERN HWND         ThisApphWnd;
EXTERN HINSTANCE    ThisApphInst;

EXTERN char ScrBuf[ROWS][COLINC];
EXTERN char KXScrBuf[KXROWS][COLINC];
EXTERN char CommonBuffer[CBUFSIZE+1];  // For any temporary use
        // Don't expect to save data here for later use if you call
        // any other functions in between.

// Although TrackScroll is default FALSE, it will become
// true once the program initializes.
GVarV( BOOL TrackScroll, FALSE );

EXTERN FileInfo KXFile;
EXTERN TextWin  FileDisp;
EXTERN TextWin  KXDisp;
EXTERN RECT     MainText;

GVarV( char EncodeStr[][4], { "TXT" _ "B5" _ "GB" _ "HZ" } );

GVarV( int  Encoding,       HZ      );


// ShowGBHZMark will become FALSE after the program initializes
GVarV( BOOL ShowGBHZMark,   TRUE    );

GVarV( int  CharWidth,      -1      );
GVarV( int  CCharWidth,     -1      );
GVarV( int  CharHeight,     -1      );
GVarV( int  LineSpace,      2       );
GVarV( int  LineHeight,     16      );
GVarV( int  FontLeading,	1 		);
GVarV( int  HZLeading,      0       );
GVarV( int  LeftMargin,     5       );

GVarV( LPSTR HZOnMark,      "~{"    );
GVarV( LPSTR HZOffMark,     "~}"    );
GVarV( int  HzOff,           2       );

GVarV( ChFontInfo GBFont,
    { "ch16.fon" _ GB _ TRUE _ 40 _ 0 _ "ch16" _ 16 } );
GVarV( ChFontInfo B5Font,
    { "bg516.fon" _ BIG5 _ FALSE _ 63 _ 0 _ "bg516" _ 16 } );
GVarV( ChFontInfo *CurrentFont, NULL );

EXTERN int  MaxFonts;          // Fonts in the Current chinese font
EXTERN int  FontGAP;   // Chinese font encoding gap in the FON file.
EXTERN HFONT hChFont[62];  // Font handles for all the Chinese fonts in a set
EXTERN HFONT hChFontBig[62];   // 24x24 fonts if using 16x16 as default.
GVarV(HFONT ASCIIFont, (HFONT)NULL);  // ASCII text font handle

// static int FontGAP = 564;    // for gb24.fon
// static int FontGAP = 470;	// for gbj/f/16.fon
// static int FontGAP = 0;		// for ch16.fon

#define MaxDictSize 200000L     // max number of bytes in dictionary
EXTERN HGLOBAL DictMem, CompDictMem;
GVarV(BYTE HUGE *Dict,          0   );
GVarV(BYTE HUGE *CompDict,      0   );
GVarV(long NDictChars,          0L  );
GVarV(long NCompDictChars,      0L  );
GVarV(int  InitDictType,        INVALID_MODE );
GVarV(int  InitCompDictType,    INVALID_MODE );

/* Half of the number of chinese characters without
   the clicked character the compound holds. */
#define HALF_COMP_SIZE  6

/* number of Chinese chars in the compound */

#define COMP_CCNUM (HALF_COMP_SIZE*2+1)
#define COMP_BYTES (COMP_CCNUM*2)
#define CLICKC_BYTE1_POS (COMP_CCNUM-1)
EXTERN BYTE ChnComp[COMP_BYTES+1];
GVarV( int CompIdx, 0 );	/* Current character in the ChnComp */

//
// End Global Variables
//
#endif // _KX_GLOBAL_H_
