#define _KX_GLOBAL_MODULE_

#define STRICT      // Strict type checking
#include <windows.h>
#include <stdio.h>
#include <mem.h>
#include "kxglobal.h"   // Global variables
#include "kxwproto.h"

void PASCAL InitGlobal( void )
{
	/* Set all global buffers to zero. */
	memset(&ScrBuf, 0, sizeof(ScrBuf));
	memset(&KXScrBuf, 0, sizeof(ScrBuf));

	FileDisp.hWnd = KXDisp.hWnd = (HWND)NULL;
	FileDisp.TopRow = KXDisp.TopRow = 0;
	FileDisp.BufTopRow = KXDisp.BufTopRow = 0;
	FileDisp.AssocFile = &KXFile;
	KXFile.hLineSize = (HLOCAL)NULL;
	FileDisp.Buf = &ScrBuf[0][0];
	FileDisp.MaxRows = ROWS;
    KXDisp.AssocFile = 0;
	KXDisp.Buf = &KXScrBuf[0][0];
    KXDisp.MaxRows = KXROWS;
	CloseFile(&FileDisp);
}
