#define STRICT      // Strict type checking
#include <windows.h>
#include <commdlg.h>
#include <stdio.h>
#include "kxglobal.h"   // Global variables
#include "kxwproto.h"	// Function Prototypes

void PASCAL ExitApp( void )
{
	CloseShengZiFile();
	DeleteChFont(); // Free fonts handles. Don't want to be
					// a resource hogger! :)
	if ( FileDisp.AssocFile->hLineSize ) {
		LocalUnlock( FileDisp.AssocFile->hLineSize );
		if ( LocalFree( FileDisp.AssocFile->hLineSize ) )
			MessageBox( NULL, "Warning: Free file mem failed.",
				"Free", MB_OK );
	}
    if ( DictMem ) {
    	GlobalUnlock( DictMem );
		if ( GlobalFree( DictMem ) )
			MessageBox( NULL, "Warning: Free dict mem failed.",
				"Free", MB_OK );
	}
    if ( CompDictMem ) {
		GlobalUnlock( CompDictMem );
		if ( GlobalFree( CompDictMem ) )
			MessageBox( NULL, "Warning: Free comp mem failed.",
				"Free", MB_OK );
	}
}

void PASCAL Quit( void )
{
    int Ans;
	Ans = MessageBox( ThisApphWnd,
		"Exit KuaiXue: Please confirm.",
		"Quit",
		MB_APPLMODAL|MB_YESNO|MB_ICONQUESTION );
	if ( Ans == IDYES ) {
		CloseFile(&FileDisp);
		DestroyWindow(FileDisp.hWnd);
		DestroyWindow(KXDisp.hWnd);
		DestroyWindow(ThisApphWnd);
	}
}

void PASCAL DeleteChFont( void )
{
	int i;

    if ( ASCIIFont ) {
		for( i = 0; i < MaxFonts; i ++ ) DeleteObject( hChFont[i] );
		DeleteObject( ASCIIFont );
	}
}

